;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  PortMon.asm
;Author: IAO
;URL: 
;
;Description:  Show bits IN From LPT.
;
;Created:  02-04-2006 Esp. (Eng. 04-02-2006)
;Finished: 14-04-2006 Esp. (Eng. 04-14-2006)
;Modified: 17-04-2006 Esp. 
;Email: rdpt465@yahoo.es
;Trabajando bin. (working well)
;With a good help from MichaelW (www.masmforum.com)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include PortMon.inc

.code

start:
	invoke  LoadDLL,hLib			;Load .Dll (Inpout32)
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke  FreeLibrary,hLib	
	invoke	ExitProcess,0

;########################################################################

DlgProc	proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	;initialization here
	.if	eax==WM_INITDIALOG


		;->This is to the Icono.	
		invoke LoadIcon,hInstance,200
        mov hIcon, eax
        invoke SendMessage,hWin,WM_SETICON,1,hIcon
		;-<

		;Put all Check Box Unchecked		(Parece que no hacen falta)		  
		invoke CheckDlgButton,hWin,IDC_RBN1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_RBN2,BST_UNCHECKED
		;mov bValue1,0

		;Esto es para el BitMap (.BMP) del Led gris.
		invoke BitmapFromResource,hInstance,IDR_JPG
		mov	hBmp,eax
		mov Carry,eax
		invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp

		;Para Encender los Led's Rojos de "Salida Puerto".
		invoke BitmapFromResource,hInstance,IDR_JPG1
		mov	hBmp1,eax

;=======================================================================
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==1
				mov eax,0
				invoke P_out1,1024,ecx
				;Procedimiento para Inicializar Led y CheckBox.
				invoke ClearAll,hWin
				
				.ELSEIF eax == IDC_RBN1 ;ID 1002 
		 			invoke IsDlgButtonChecked,hWin,IDC_RBN1
					mov LptVal,378h
					  ;Here the call to the procedure "TimerProc"	
				      invoke SetTimer,hWin,1,500,ADDR TimerProc

	    		 .ELSEIF eax == IDC_RBN2 ;ID 1004 
		 			 invoke IsDlgButtonChecked,hWin,IDC_RBN2
					 mov LptVal,3BCh
				      ;Here the call to the procedure "TimerProc"
				      invoke SetTimer,hWin,1,500,ADDR TimerProc
	
			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif	eax==WM_CLOSE
	       invoke KillTimer,hWin,1
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp


;========================================================================
LoadDLL PROC hLibrary:DWORD
;Carga de la DLL y Funcion
  invoke LoadLibrary,addr DLLName
		.if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        	.else
                mov hLib,eax

                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                    invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                	.else
                	mov InAddr,eax      ;Carga el handle en InAddr
           		.endif

                invoke GetProcAddress,hLib,addr FunctionName2
                .if eax==NULL
                    invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                	.else
					mov OutAddr,eax     ;Carga el handle en OutAddr
           		.endif
		.endif
;Final Carga DLL y Funcion In and Out32	
	
	ret
LoadDLL endp

;========================================================================
P_In PROC PortAddress:DWORD
		
		mov  eax,LptVal	
		mov  PortAddress,eax ;
		push PortAddress

 		;Put here work.
		call [InAddr]    ;Despliega el Contenido de InAddr

		pop  PortAddress	
    ret
P_In endp

;========================================================================
P_out1 PROC PortAddress:DWORD, data:DWORD
		
			
		mov data,eax
		push data
		mov  eax,LptVal	
		mov  PortAddress,eax ;
		push PortAddress

 		;Put here work.
		call [OutAddr]    ;Despliega el Contenido de OutAddr

		pop  PortAddress	
		pop  data
    ret
P_out1 endp

;========================================================================
ClearAll PROC hWin:DWORD
		;Esto es para el BitMap (.BMP)
		;invoke BitmapFromResource,hInstance,IDR_JPG
		mov eax,Carry
		mov	hBmp,eax
		invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp

	ret

ClearAll endp

;========================================================================
TimerProc proc hWin:DWORD,uMsg:DWORD,idEvent:DWORD,dwTime:DWORD

	invoke P_In,1024 	;In from LPT Port.
	mov Val_In,eax
;=====================================================================
Entrada:
			.IF Val_In & 01h ;1 Decimal
  	        invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE 
			invoke SendDlgItemMessage,hWin,IDC_IMG1,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif

			.IF Val_In & 02h ;2 Decimal
			invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG2,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif

			.IF Val_In & 04h ;4 Decimal
			invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG3,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif
	
			.IF Val_In & 08h ;8 Decimal
  	        invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG4,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif

			.IF Val_In & 10h ;16 Decimal
  	        invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG5,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif
			
			.IF Val_In & 20h ;32 Decimal
  	        invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG6,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif
			
			.IF Val_In & 40h ;64 Decimal
  	        invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG7,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif

			.IF Val_In & 80h ;128 Decimal
  	        invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp1
			.ELSE
			invoke SendDlgItemMessage,hWin,IDC_IMG8,STM_SETIMAGE,IMAGE_BITMAP,hBmp
			.endif 
    ret
TimerProc endp

;========================================================================

end start

