;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsmG2.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.  
;
;Created:  21-09-2005 Esp. (Eng. 09-21-2005)
;Finished: 22-09-2005 Esp. (Eng. 09-22-2005)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

;#########################################################################
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include LedAsmG2.inc

.code
start:
	;call LoadDLL		;Funciona pero quera usar invoke
	invoke LoadDLL,hLib

	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke FreeLibrary,hLib  
	invoke	ExitProcess,0

;########################################################################
DlgProc	proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		;initialization here

		; Tres Lineas del Icono		
        invoke LoadIcon,hInstance,200
        mov hIcon, eax
        invoke SendMessage,hWin,WM_SETICON,1,hIcon

		mov	eax,uMsg
		.elseif	eax==WM_CLOSE 
		invoke	EndDialog,hWin,0
        
    	;Procesa los mensajes de los botones
    	mov	eax,uMsg    
		.elseif	eax==WM_COMMAND
;---------------------------------------------------------------------------
;AQUI ESTA UNA DE LAS PRINCIPALES DIFERENCIAS.
;HERE THIS ONE OF THE MAIN DIFFERENCES.
			.if wParam == IDOK
 					invoke	SendMessage,hWin,WM_CLOSE,0,0
				.elseif wParam == IDCANCEL	
					invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL			
				.elseif wParam == 1001
					;call  P_out1              ;Funciona pero se tranca el programa	(BAD)
					invoke P_out1,DWORD,DWORD
				.elseif wParam == 1002
					;call  P_out2              ;Funciona pero se tranca el programa	(BAD)
					invoke P_out2,DWORD,DWORD
				
			.endif
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

;########################################################################
LoadDLL PROC hLibrary:DWORD
;Carga de la DLL y Funcion
	  invoke LoadLibrary,addr DLLName
        .if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        	.else
                mov hLib,eax
                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                        invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                
                .else
                mov OutAddr,eax     ;Carga el handle en OutAddr
                ;call P_out1          ; Get the addresses of the procedures
           .endif
	 .endif
;Final Carga DLL y Funcion Out32	
	
	ret
LoadDLL endp

;########################################################################
P_out1 PROC PortAddress:DWORD , data:DWORD
		mov data,0    ;240 ;128 ;  ;255        
		push data
		mov  PortAddress,378h
		push PortAddress

;Puesto Aqui funciona.
		call [OutAddr]    ;Despliega el Contenido de TestAddr

		pop  PortAddress	
		pop  data
		;mov eax,OutAddr
		
    ret
P_out1 endp

;########################################################################
P_out2 PROC PortAddress2:DWORD , data2:DWORD
		mov data2,255    ;240 ;128 ;  ;255        
		push data2
		mov  PortAddress2,378h
		push PortAddress2

;Puesto Aqui funciona.
		call [OutAddr]    ;Despliega el Contenido de TestAddr
		
		pop  PortAddress2	
		pop  data2
		
		
    ret
P_out2 endp

;########################################################################
end start
