;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsmG4
;Author: IAO
;URL: 
;
;Description:  Program send bits to LPT
;
;Created:  05-08-2005 Esp. (Eng. 08-05-2005)
;Finished: 28-08-2005 Esp. (Eng. 08-28-2005)
;Modified: 02-04-2006 Esp. 
;Email: rdpt465@yahoo.es
;Trabajando bin. (working well)
;With a good help from MichaelW, (www.masmforum.com)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 


.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include LedAsmG4.inc

.code
start:
	invoke  LoadDLL,hLib
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke  FreeLibrary,hLib
	invoke	ExitProcess,0

;==================================================================================
DlgProc	proc  hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL pMem  :DWORD
    LOCAL rpos  :DWORD
    LOCAL buffer[128]:BYTE

	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
	;initialization here

		;Ejecuta programa detector de Address Lpt.
		;It executes the program: To detect the address Lpt.
		fn shell_ex,"ConvStri.com",HIGH_PRIORITY_CLASS ;<--Helped for: CrisLesli

		;Esto es para el Icono.	(For the Icon).
		invoke LoadIcon,hInstance,200
        mov hIcon, eax
        invoke SendMessage,hWin,WM_SETICON,1,hIcon

		;-Muestra la Direccin LPT1 en: EditText "Address LPT1".
		;-It shows the Address LPT1 in: EditText "Address LPT1".
		mov hEdit1, FUNC(GetDlgItem,hWin,1009)
        mov pMem, InputFile("Addr.ini")     ; load the INI file into memory
        mov rpos, 0                         ; zero the read position pointer
        mov rpos, linein$(pMem,ADDR buffer,rpos)
        invoke SendMessage,hEdit1,WM_SETTEXT,0,ADDR buffer
        free pMem                           ; free the memory 

		;Put all CheckBox Unchecked		(Parece que no hacen falta)					  
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
		mov bValue1,0
		; 

		;Esto es para el Edit BOX. "Value Write to Port".
		invoke GetDlgItem, hWin, 1026 ;IDC_EDT2
		mov hEdit2, eax

		
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==1 ;"Cero To Port"

				;Coloca todos los CHECKBOX UNCHECKED.
				;All the other CHECKBOX UNCHECKED.
				invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
				invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
				
				;Coloca en Cero EditBOX: "Value Write to Port".
				;It places in Zero EditBOX:	"Value Write to Port".
				mov eax,0
				mov Val_Dat,eax				
				INVOKE SetDlgItemInt,hWin,1026,Val_Dat,FALSE
				;Clear Lpt output.
				mov eax,0
				invoke P_out1,DWORD,DWORD

	.elseif eax==2 ;"EXIT"
			;-->Esto pregunta si sale del programa. (This asks if it leaves the program). 
			;Aqu, fue que funcion.(Here it worked).
			invoke MessageBox,hWin,addr Pregnta,addr Salir,MB_YESNO or MB_ICONQUESTION
       		 .if eax == IDNO
       		  ret
	    	 .else
 			 invoke SendMessage,hWin,WM_CLOSE,0,0
       		 .endif
			;---<
			
			invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL

;=============================================================
;Para los CHECKBOX. (For the CHECKBOX)
		;======================
	.elseif eax == IDC_CHK0  
		invoke IsDlgButtonChecked,hWin,IDC_CHK0 
		.if eax!=0		   	;Si esta Cheked (This chequed).
		;Coloca todos los otros CHECKBOX UNCHECKED.
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,1     	;Valor1 
			.else 		   	;Sino es 1 (If not is 1)
				mov eax,0 	;Value0 
		.endif
		jmp Salida

		;======================
	.elseif eax == IDC_CHK1
		invoke IsDlgButtonChecked,hWin,IDC_CHK1
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,2 		;Value2
			.else 
				mov eax,0 	;Value0		 
		.endif
		jmp Salida 		

		;======================
	.elseif eax == IDC_CHK2		
		invoke IsDlgButtonChecked,hWin,IDC_CHK2		
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,4 
			.else 
				mov eax,0 
		.endif
		jmp Salida		

		;======================
	.elseif eax == IDC_CHK3		
		invoke IsDlgButtonChecked,hWin,IDC_CHK3
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,8 
			.else 
				mov eax,0 
		.endif
		jmp Salida		

		;======================
	.elseif eax == IDC_CHK4		
		invoke IsDlgButtonChecked,hWin,IDC_CHK4
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,16 
			.else 
				mov eax,0 
		.endif
		jmp Salida		

		;======================
	.elseif eax == IDC_CHK5		
		invoke IsDlgButtonChecked,hWin,IDC_CHK5
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,32 
			.else 
				mov eax,0
		.endif
		jmp Salida		

		;======================
	.elseif eax == IDC_CHK6		
		invoke IsDlgButtonChecked,hWin,IDC_CHK6
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK7,BST_UNCHECKED
			mov eax,64 
			.else 
				mov eax,0 
		.endif
		jmp Salida		

		;======================
	.elseif eax == IDC_CHK7		
		invoke IsDlgButtonChecked,hWin,IDC_CHK7
		.if eax!=0
		;All the other CHECKBOX UNCHECKED.
		invoke CheckDlgButton,hWin,IDC_CHK0,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK1,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK2,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK3,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK4,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK5,BST_UNCHECKED
		invoke CheckDlgButton,hWin,IDC_CHK6,BST_UNCHECKED
			mov eax,128 
			.else 
				mov eax,0 
		.endif
		jmp Salida
Salida:
		
		;Variable for the EditBOX: "Value Write to Port"		
		mov Val_Dat,eax			

		invoke P_out1,DWORD,DWORD

		;It shows the value in EDITBOX: "Value Write to Port".
		INVOKE SetDlgItemInt,hWin,1026,Val_Dat,FALSE
		
;=============================================================

			.endif
		.endif
	.elseif	eax==WM_CLOSE
		invoke	EndDialog,hWin,0

		;Here delete file Addr.ini.
    	.if rv(exist,"Addr.ini") != 0         ;If file already exists
      	test fdelete("Addr.ini"),eax          ;Delete it
    	.endif		

	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

;========================================================================
LoadDLL PROC hLibrary:DWORD
;Carga de la DLL y Funcion
	  invoke LoadLibrary,addr DLLName
        .if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        	.else
                mov hLib,eax
                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                    invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                .else
                mov OutAddr,eax     ;Carga el handle en OutAddr
           .endif
	 .endif
;Final Carga DLL y Funcion Out32	
	
	ret
LoadDLL endp

;========================================================================
P_out1 PROC PortAddress:DWORD, data:DWORD
		mov data,eax
		push data
		mov  PortAddress,378h
		push PortAddress

 		;Here it worked.
		call [OutAddr]    ;Despliega el Contenido de TestAddr

		pop  PortAddress	
		pop  data
    ret
P_out1 endp

;========================================================================

end start


